#pragma warning( disable:4786 )
#include <iostream>
#include <fstream>
#include <string>
#include <vector>

using namespace std;
typedef vector<string>strlist_t;

void readv( strlist_t &slist )
{
   slist.clear();
   ifstream in( "input.dat" );
   string s;

   if (in.fail()) {
      cout << "failed to open file" << endl;
      return;
   }
   getline(in,s);
   while (in.good()) {
      slist.push_back( s );
      getline(in,s);
   }
}

void writev( ostream &os, strlist_t &slist )
{
   strlist_t::const_iterator i;
   for (i=slist.begin();
        i!=slist.end();
        i++) {
           os << *i << endl;
   }
}


int main()
{
   strlist_t slist;
   readv( slist );
   writev( cout, slist );

   ofstream os( "Output.dat" );
   if (os.is_open())
      writev( os, slist );

   return 0;
}